#!/usr/local/bin/perl

use Win32::GUI;
use Win32 ();
use Win32::GUI::Loft;
use LWP::Simple;
use Archive::Any;
use Win32::Process;
use Win32::TieRegistry( Delimiter=>"#", ArrayValues=>0 );
		$pound= $Registry->Delimiter("/");
use Cwd;

my $version="1.0.0";

my $dir = cwd();
$dir =~ s/\//\\/g;

my $uname=$ENV{USERNAME};
$uname||="2Remail";

my $etemp=$ENV{TEMP};
$etemp||="c:\\temp";

my $temp = "$etemp\\pdk-$uname-$$";

# Some globals
my ($mail2news,$chain,$copies,$psetm2n,$psetchain,%CONF,$hashflag,$nm,$ltm, $mixreg);
my (@addheaders,@headers,@body,@stripheaders,@hashheaders,$win,$freewin,$sflg);

unless($Registry->{"LMachine/Software/Packetderm/2Remail/"}){
	$Registry->{"LMachine/Software/Packetderm/"} = {"2Remail/" => {"/Path" => "$dir"}};
}

if($Registry->{"CUser/Software/Mixmaster/"}){
	$mixdir = $Registry->{"CUser/Software/Mixmaster/MixDir"};
 	delete $Registry->{"CUser/Software/Mixmaster/MixDir"};

}

my $path = $Registry->{"LMachine/Software/Packetderm/2Remail/Path"}
    or  die "LMachine/Software/Packetderm/2Remail//Path value: $^E\n";

## If there is no config, write one, otherwise read it.
my $config = "$path\\2remail.conf";

unless (-e $config){
	&newconfig();
}

## Get config
&readconf();
my $debug=$CONF{'debug'};
my $PORT=$CONF{'nntpport'};
my $m2n=$CONF{'mail2news'};
my $defrem=$CONF{'chain'};
my $defcopies=$CONF{'copies'};
my $quiet=$CONF{'quiet'};
my $mixpath=$CONF{'mixpath'};
my $mixconf=$CONF{'mixconf'};
my $type2=$CONF{'type2'};
my $newsserver=$CONF{'newsserver'};
my $newsport=$CONF{'newsport'};
my $pubring=$CONF{'pubring'};
my $mlist2=$CONF{'mlist2'};
my $mixexe=$CONF{'mixexe'};
my $mixzip=$CONF{'mixzip'};
my $postfile=$CONF{'postfile'};

# untaint
if($debug ne "yes"){
	if($mixpath !~ /^([a-zA-Z0-9\.\\_\-\:\~]+)$/){
		Win32::GUI::MessageBox(0, "Invalid character in mixmaster path.", "Error:");
		exit;
	}else{
		$mixpath=$1;
	}

	if($mixexe !~ /^([a-zA-Z0-9\.\\_\-\:\~]+)$/){
		Win32::GUI::MessageBox(0, "Invalid character in mixmaster exe.", "Error:");
		exit;
	}else{
		$mixexe=$1;
	}
}

if($mixzip){
	if($mixzip !~ /^([a-zA-Z0-9\.\\_\-\:\~\/]+)$/){
		Win32::GUI::MessageBox(0, "Invalid character in mixmaster zipfile.", "Error:");
		exit;
	}else{
		$mixzip=$1;
	}
}

if($debug eq "yes"){
	if($postfile !~ /^([a-zA-Z0-9\.\\_\-\:\~]+)$/){
		Win32::GUI::MessageBox(0, "Invalid character in post file.", "Error:");
		exit;
	}else{
		$postfile=$1;
	}
}

if($newsserver !~ /^([a-zA-Z0-9\.\-]+)$/){
	Win32::GUI::MessageBox(0, "Invalid character in news server.", "Error:");
	exit;
}else{
	$newsserver=$1;
}

if($newsport !~ /^([0-9]+)$/){
	Win32::GUI::MessageBox(0, "Invalid character in news port.", "Error:");
	exit;
}else{
	$newsport=$1;
}

#$ENV{PATH} = $mixpath;
$ENV{MIXPATH} = $mixpath;
$ENV{MIXDIR} = $mixpath;


eval { main(); };
Win32::GUI::MessageBox(0, "My Error: $@", "2Remail") if($@);



sub main {
	my $fileWindow = "$temp\\2r.gld";
	my $objDesign = Win32::GUI::Loft::Design->newLoad($fileWindow) or 
			die("Could not open window file ($fileWindow)");			
	$win = $objDesign->buildWindow() 
			or die("Could not build window ($fileWindow)");
	$win->Show();
	Win32::GUI::Dialog ();
	return(1);
	}

sub ::Main_Activate {
 defined($win = $Win32::GUI::Loft::window{Main}) or return(1);
	&updatebuttons();
	if($sflg ne "yes"){
		$sflg = "yes";
		$win->StatusBar->Text("2Remail v. $version");
	}
	return(1);
}

sub ::Main_Terminate { defined($win = $Win32::GUI::Loft::window{Main}) or return(1);
	if(defined $nntppid){
		Win32::Process::KillProcess($nntppid,1);
	}
	if(defined $mixrand){
		Win32::Process::KillProcess($mixrand,1);
	}
	Win32::Process::Create($ProcessObj,
                                "$mixpath\\$mixexe",
                                "$mixexe -S",
                                1,
                                CREATE_NO_WINDOW,
                                $mixpath)|| $win->Output->Append("Error processing pool.\r\n");
	$win->Output->Append("Mixmaster instructed to send messages.\r\n");
	if($Registry->{"LMachine/Software/Packetderm/"}){
		delete $Registry->{"LMachine/Software/Packetderm/2Remail/"};
		delete $Registry->{"LMachine/Software/Packetderm/"};
	}
	if($mixdir){
		$Registry->{"CUser/Software/Mixmaster/"} = {"/MixDir" => "$mixdir"};
	}
	return(-1);
	}

sub ::btnStartNNTP_Click { defined($win = $Win32::GUI::Loft::window{Main}) or return(1);
    my $n2r="$temp\\n2r.exe";
		Win32::Process::Create($ProcessObj,
                                "$n2r",
                                "n2r",
                                1,
                                CREATE_NEW_CONSOLE,
                                $temp)|| $win->Output->Append("Error launching NNTP proxy.\r\n");
                                
  $nntppid=$ProcessObj->GetProcessID();
  if ($nntppid){
  	$win->Output->Append("NNTP proxy started on port $PORT - see proxy window for details\r\n");
		$win->StatusBar->Text("NNTP Proxy Running.");
  	$win->btnStartNNTP->Hide();
  	$win->btnStopNNTP->Show();
	}
	return(1);
}
	
sub ::btnStopNNTP_Click { 
	defined($win = $Win32::GUI::Loft::window{Main}) or return(1);
	&updatebuttons();
	if(defined $nntppid){
		Win32::Process::KillProcess($nntppid,1);
  	$win->Output->Append("NNTP Proxy Shut down\r\n");
		$win->StatusBar->Text("NNTP Proxy stopped.");
  	$win->btnStopNNTP->Hide();
  	$win->btnStartNNTP->Show();
  }
	return(1);
}

sub ::btnInstallMix_Click { 
	defined($win = $Win32::GUI::Loft::window{Main}) or return(1);
	&updatebuttons();
	&installmix();
 	$win->btnInstallMix->Hide();
  $win->btnEditMixConfig->Show();
	return(1);
}

sub ::btnEditMixConfig_Click { 
	defined($win = $Win32::GUI::Loft::window{Main}) or return(1);
	&updatebuttons();
	Win32::Process::Create($ProcessObj,
                                "$ENV{WINDIR}\\notepad.exe",
                                "notepad $mixpath\\$mixconf",
                                1,
                                NORMAL_PRIORITY_CLASS,
                                ".")|| $win->Output->Append("Error editing mixmaster config.\r\n");
	return(1);
	}
	
sub ::btnEditConfig_Click { 
	defined($win = $Win32::GUI::Loft::window{Main}) or return(1);
	&updatebuttons();
	Win32::Process::Create($ProcessObj,
                                "$ENV{WINDIR}\\notepad.exe",
                                "notepad $config",
                                1,
                                NORMAL_PRIORITY_CLASS,
                                ".")|| $win->Output->Append("Error editing main config.\r\n");
	return(1);
	}

sub ::btnUpdateStats_Click { 
	defined($win = $Win32::GUI::Loft::window{Main}) or return(1);
	&updatebuttons();
	&get_stats();
	return(1);
	}

sub ::btnSendPool_Click { 
	defined($win = $Win32::GUI::Loft::window{Main}) or return(1);
	&updatebuttons();
	Win32::Process::Create($ProcessObj,
                                "$mixpath\\$mixexe",
                                "$mixexe -S",
                                1,
                                CREATE_NO_WINDOW,
                                $mixpath)|| $win->Output->Append("Error processing pool.\r\n");
	$win->Output->Append("Mixmaster instructed to send messages.\r\n");
	return(1);
	}

sub ::btnDummy_Click { 
	defined($win = $Win32::GUI::Loft::window{Main}) or return(1);
	&updatebuttons();
	Win32::Process::Create($ProcessObj,
                                "$mixpath\\$mixexe",
                                "$mixexe -d",
                                1,
                                CREATE_NO_WINDOW,
                                $mixpath)|| $win->Output->Append("Error adding dummy message.\r\n");
	$win->Output->Append("Added decoy message to pool.\r\n");
	return(1);
	}


## Sub routines

## Get stats
sub get_stats{
defined($win = $Win32::GUI::Loft::window{Main}) or return(1);
	$win->Output->Append("Updating stats...\r\n");
	$mixpath =~ /^(.*)$/;
	my $mp=$1;
	my $file1 = "$mp\\type2.list\n";
	if(is_success(getstore($type2,$file1))){
		$win->Output->Append("Saved $type2\r\n");
	}else{
		$win->Output->Append("Error retrieving $type2\r\n");
	}
	my $file2 = "$mp\\pubring.mix\n";
	if(is_success(getstore($pubring,$file2))){
		$win->Output->Append("Saved $pubring\r\n");
	}else{
		$win->Output->Append("Error retrieving $pubring\r\n");
	}
	my $file3 = "$mp\\mlist.txt\n";
	if(is_success(getstore($mlist2,$file3))){
		$win->Output->Append("Saved $mlist2\r\n");
	}else{
		$win->Output->Append("Error retrieving $mlist2\r\n");
	}
}

## Read configuration file
sub readconf{
	my $strhdrflag="";
	my $addhdrflag="";
	my @stripheaders;
	my @addheaders;
	open CONFIG, $config;
	while (<CONFIG>) {
		next unless /\S/;
		next if /^\#/;
		if(/Stripped Headers/){$strhdrflag="yes";next;}
		if(/Added Headers/){$addhdrflag="yes";next;}
		if($strhdrflag ne "yes"){	
			if($addhdrflag ne "yes"){
				s/ //g;
				my $a;
				my $b;
				($a, $b) = split('=');
				chomp($b);            
				$CONF{$a} = $b;
			}
		}
		if($strhdrflag eq "yes"){
			if($addhdrflag ne "yes"){
				$_ = lc($_);
				push(@stripheaders,$_);
			}else{
				push(@addheaders,$_);
			}
		}
	}
	close CONFIG;

}

## Install mixmaster
sub installmix {
	unless (-d $mixpath){
        mkdir ($mixpath) || Win32::GUI::MessageBox(0, "Unable to create mixpath.", "Error:");;
	}
	my $file = "$mixpath\\mixmaster.zip";
	if(-e $file){
		$win->Output->Append("Extracting to $mixpath\r\n");
		my $archive = Archive::Any->new($file);
		chdir $mixpath;
  	$archive->extract;
  }else{
  	if($mixzip eq ""){$win->Output->Append("No file configured to download.\r\n");return;}
  	$win->Output->Append("Downloading $mixzip\r\n");
		if(is_success(getstore($mixzip,$file))){
			$win->Output->Append("Saved $mixzip\r\n");
		}else{
			$win->Output->Append("Error retrieving $mixzip\r\n");
			return;
		}
		$win->Output->Append("Extracting to $mixpath\r\n");
		my $archive = Archive::Any->new($file);
		chdir $mixpath;
  	$archive->extract;
	}
	
	&newmixconfig();
	$win->Output->Append("Launching process to create mixrand.bin.\r\n");
	$win->Output->Append("Enter random characters. Hit enter until complete.\r\n");
#	system("$mixpath\\$mixexe -help");
	Win32::Process::Create($ProcessObj,
                                "$mixpath\\$mixexe",
                                "$mixexe -help",
                                1,
                                CREATE_NEW_CONSOLE,
                                ".")|| $win->Output->Append("Error creating mixrand.bin!\r\n");
  my $mixrand=$ProcessObj->GetProcessID();
  &get_stats();
  $win->Output->Append("2Remail Ready. Please check Main Config.\r\n");
}

sub updatebuttons {
	my $mf="$mixpath\\$mixexe";
	if (-e $mf){
		$win->btnInstallMix->Hide();
		$win->btnEditMixConfig->Show();
		$win->btnUpdateStats->Show();
		$win->btnSendPool->Show();
		$win->btnDummy->Show();
	}else{
		$win->btnInstallMix->Show();
		$win->btnEditMixConfig->Hide();
		$win->btnStartNNTP->Hide();
		$win->btnStopNNTP->Hide();
		$win->btnUpdateStats->Hide();
		$win->btnSendPool->Hide();
		$win->btnDummy->Hide();
		return;
	}
	if (kill(0, $nntppid)){
  	$win->btnStartNNTP->Hide();
  	$win->btnStopNNTP->Show();
	}else{
		$win->StatusBar->Text("NNTP Listener Stopped.");
		$win->btnStartNNTP->Show();
  	$win->btnStopNNTP->Hide();
  }
return;
}	

sub newmixconfig {
	open(MIXCONF,">$mixpath\\$mixconf");
	print MIXCONF "########################## Client Configuration #############
ERRLOG error.log
REMAIL n
MINREL 80
RELFINAL 90
MAXLAT 6h
SENDPOOLTIME 0h
SMTPRELAY  panta-rhei.dyndns.org
# HELONAME your.helo.name
";
	close (MIXCONF);
}

sub newconfig {
		open(CONF,">$config");
	print CONF "################################################################
## 2Remail Configuration File
##
## http://www.cotse.net/2remail/
## Copyright Packetderm, LLC
################################################################

# When set to yes the post is put in the file.  It is not posted.
# Left in from development for you to use to check headers, etc.
debug=no
postfile=$path\\News2Remail-Test-Post.txt

# Mixmaster download
# This is the latest compiled windows version that I can find, 
# the version Richard provides with QuickSilver.  I have mirrored
# that version on Cotse only so that we pay the cost of the
# bandwidth instead of Richard having to pay it for people using
# 2Remail.  You may get it from either source. You may also
# download it and place it in the mixpath directory as
# mixmaster.zip and Install Mix will use that instead of
# downloading. 
#ftp://ftp.quicksilvermail.net/pub/quicksilver/Mix29b39.zip
mixzip=http://www.cotse.com/mixmaster/Mix29b39.zip

# Path to mixmaster and exe name (for compat with diff versions)
# You should not have to change this.
mixpath=$path\\mixmaster
mixconf=mix.cfg
mixexe=mix.exe

# Local port for NNTP Listener to listen on
nntpport=1990

# News server information
# Enter your NSP information here.
# (where you now get your news)
newsserver=your.newsserver.com
newsport=119

# Default m2n, chain, and copies.
mail2news=mail2news\@dizum.com,mail2news\@remailer.org.uk,mail2news\@nym.alias.net,mail2news\@news.demon.co.uk
chain=*,borked
copies=5

## stats and keys
type2=http://pinger.bananasplit.info/type2.list
pubring=http://pinger.bananasplit.info/pubring.mix
mlist2=http://pinger.bananasplit.info/mlist2.txt

# Comment out to listen on all available IPs
localonly=yes

[Stripped Headers]
User-Agent:
X-Newsreader:
Organization:

[Added Headers]

";
	close(CONF);
}